#!/usr/bin/perl

use Curl::easy;

# First, do an http download:

# Read URL to get
$defurl = "http://vivaldi.koblenz-net.lan/cgi-bin/test-cgi";
print "Please enter an URL for http download [$defurl]: ";
$url = <STDIN>;
if ($url =~ /^\s*\n/) {
    $url = $defurl;
}

# Init the curl session
$curl = Curl::easy::init();

# Set URL to get
Curl::easy::setopt($curl, Curl::easy::CURLOPT_URL, $url);

# No progress meter please
Curl::easy::setopt($curl, Curl::easy::CURLOPT_NOPROGRESS, 1);

# Shut up completely
Curl::easy::setopt($curl, Curl::easy::CURLOPT_MUTE, 1);

# Store error messages in $errbuf
$errbuf = "";
Curl::easy::setopt($curl, Curl::easy::CURLOPT_ERRORBUFFER, "errbuf");

# Store headers and content into internal variables, instead of writing
# them to a file. Headers are stored into $Curl::easy::headers, content
# into $Curl::easy::content
Curl::easy::internal_setopt(Curl::easy::USE_INTERNAL_VARS, 1);
Curl::easy::internal_setopt(Curl::easy::USE_INTERNAL_DEBUG, 1);

# Go get it
if (Curl::easy::perform($curl) == 0) {
    Curl::easy::getinfo($curl, Curl::easy::CURLINFO_SIZE_DOWNLOAD, $bytes);
    print "ok: $bytes bytes read\n\n";
    print "Debug:\n$Curl::easy::debug\n";
    print "Headers:\n$Curl::easy::headers\n";
    print "Content:\n$Curl::easy::content\n";
    Curl::easy::getinfo($curl, Curl::easy::CURLINFO_EFFECTIVE_URL, $realurl);
    Curl::easy::getinfo($curl, Curl::easy::CURLINFO_HTTP_CODE, $httpcode);
    print "Effective fetched url (http code: $httpcode) was: $realurl\n";
    Curl::easy::getinfo($curl, Curl::easy::CURLINFO_TOTAL_TIME, $total);
    Curl::easy::getinfo($curl, Curl::easy::CURLINFO_NAMELOOKUP_TIME, $dns);
    Curl::easy::getinfo($curl, Curl::easy::CURLINFO_CONNECT_TIME, $conn);
    Curl::easy::getinfo($curl, Curl::easy::CURLINFO_PRETRANSFER_TIME, $pre);
    Curl::easy::getinfo($curl, Curl::easy::CURLINFO_STARTTRANSFER_TIME, $start);
    print "times are: dns: $dns, connect: $conn, pretransfer: $pre, starttransfer: $start, total: $total.\n";
} else {
    # We can acces the error message in $errbuf here
    print "ko $i: '$errbuf'\n";
}

# Cleanup
Curl::easy::cleanup($curl);

